//+------------------------------------------------------------------+
//|                                                  OpenCloseMA.mq4 |
//+------------------------------------------------------------------+
//+------------------------------------ ------------------------------+
//| TypicalPriceOpenClose.mq4                                         |
//| Copyright  2008, MetaQuotes Software Corp.                       |
//| http://www.metaquotes.net                                         |
//+------------------------------------ ------------------------------+
#property copyright "Copyright  2008, MetaQuotes Software Corp."
#property link "http://www.metaquotes.net"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Gold
#property indicator_width1 2 

extern ENUM_TIMEFRAMES TimeFrame = PERIOD_CURRENT;
extern int MA_Period = 1;
extern int MA_Method = 0;
 
//---- buffers
double ExtMapBuffer1[];
//+------------------------------------ ------------------------------+
//| Custom indicator initialization function |
//+------------------------------------ ------------------------------+
int init()
{
//---- indicators
SetIndexStyle(0,DRAW_LINE);
SetIndexBuffer(0,ExtMapBuffer1);
TimeFrame = MathMax(TimeFrame,_Period);

//----
return(0);
}
//+------------------------------------ ------------------------------+
//| Custom indicator deinitialization function |
//+------------------------------------ ------------------------------+
int deinit()
{
//----

//----
return(0);
}
//+------------------------------------ ------------------------------+
//| Custom indicator iteration function |
//+------------------------------------ ------------------------------+
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(MathMax(Bars-counted_bars,2*TimeFrame/_Period),Bars-1);

for(int i = limit; i >= 0; i--){
int y = iBarShift(NULL,TimeFrame,Time[i]);
double OpenMA = iMA(NULL,TimeFrame,MA_Period,0,MA_Method,0,y);
double CloseMA = iMA(NULL,TimeFrame,MA_Period,0,MA_Method,1,y);
ExtMapBuffer1[i] = (OpenMA+CloseMA)/2.0;
}

return(0);
}